## batman-adv-kernelland 0.1

=== Makefile ===
#
# Copyright (C) 2007-2008 B.A.T.M.A.N. contributors:
# Marek Lindner, Simon Wunderlich
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 2 of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA
#



PWD:=$(shell pwd)
ifeq ($(wildcard $(KERNELPATH)),)
KERNELPATH = /lib/modules/$(shell uname -r)/build
# sanity check: does KERNELPATH exist?
ifeq ($(shell cd $(KERNELPATH) && pwd),)
$(error $(KERNELPATH) is missing, please set KERNELPATH)
endif
export KERNELPATH
endif

REVISION=	$(shell if [ -d .svn ]; then \
						if which svn > /dev/null; then \
							svn info | grep "Rev:" | sed -e '1p' -n | awk '{print $$4}'; \
						else \
							echo "[unknown]"; \
						fi ; \
					else \
						if [ -d ~/.svk ]; then \
							if which svk > /dev/null; then \
								echo $$(svk info | grep "Mirrored From" | awk '{print $$5}'); \
							else \
								echo "[unknown]"; \
							fi; \
						fi; \
					fi)

NUM_CPUS = $(shell NUM_CPUS=`cat /proc/cpuinfo | grep -v 'model name' | grep processor | tail -1 | awk -F' ' '{print $$3}'`;echo `expr $$NUM_CPUS + 1`)

include $(PWD)/Makefile.kbuild

all:
	make -C $(KERNELPATH) REVISION=$(REVISION) M=$(PWD) PWD=$(PWD) -j $(NUM_CPUS) modules

clean:
	make -C $(KERNELPATH) M=$(PWD) PWD=$(PWD) clean

## batman-adv-kernelland 0.2

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #
-# Copyright (C) 2007-2008 B.A.T.M.A.N. contributors:
+# Copyright (C) 2007-2009 B.A.T.M.A.N. contributors:
+#
 # Marek Lindner, Simon Wunderlich
+#
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of version 2 of the GNU General Public
 # License as published by the Free Software Foundation.
@@ -19,27 +21,22 @@
 
 
 PWD:=$(shell pwd)
-ifeq ($(wildcard $(KERNELPATH)),)
-KERNELPATH = /lib/modules/$(shell uname -r)/build
+KERNELPATH ?= /lib/modules/$(shell uname -r)/build
 # sanity check: does KERNELPATH exist?
 ifeq ($(shell cd $(KERNELPATH) && pwd),)
-$(error $(KERNELPATH) is missing, please set KERNELPATH)
+$(warning $(KERNELPATH) is missing, please set KERNELPATH)
 endif
+
 export KERNELPATH
-endif
 
 REVISION=	$(shell if [ -d .svn ]; then \
 						if which svn > /dev/null; then \
 							svn info | grep "Rev:" | sed -e '1p' -n | awk '{print $$4}'; \
-						else \
-							echo "[unknown]"; \
-						fi ; \
+						fi; \
 					else \
 						if [ -d ~/.svk ]; then \
 							if which svk > /dev/null; then \
 								echo $$(svk info | grep "Mirrored From" | awk '{print $$5}'); \
-							else \
-								echo "[unknown]"; \
 							fi; \
 						fi; \
 					fi)
@@ -49,7 +46,7 @@
 include $(PWD)/Makefile.kbuild
 
 all:
-	make -C $(KERNELPATH) REVISION=$(REVISION) M=$(PWD) PWD=$(PWD) -j $(NUM_CPUS) modules
+	$(MAKE) -C $(KERNELPATH) REVISION=$(REVISION) M=$(PWD) PWD=$(PWD) -j $(NUM_CPUS) modules
 
 clean:
-	make -C $(KERNELPATH) M=$(PWD) PWD=$(PWD) clean
+	$(MAKE) -C $(KERNELPATH) M=$(PWD) PWD=$(PWD) clean

=== debian/changelog ===
batman-adv-kernelland (0.2-5) unstable; urgency=low

  * Correct spelling errors found by lintian
  * Use dkms postinst script for batman-adv-dkms (Closes LP: #497149)

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Thu, 14 Jan 2010 00:01:22 +0100

batman-adv-kernelland (0.2-4) unstable; urgency=low

  * Add ${misc:Depends} debhelper for batman-adv-source
  * debian/patches:
    - Add route_flapping.patch, decrease route flapping in perfect environments
    - Add random_mac.patch, Copy complete 6 bytes of a random ethernet address

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Sat, 02 Jan 2010 00:15:50 +0100

batman-adv-kernelland (0.2-3) unstable; urgency=low

  * debian/patches:
    - Add missing_kfree.patch, Introduce missing kfree in case of failed
      allocation of packet buffer
    - Add irqdeadlock.patch, Use forw_bcast_list_lock always in disabled
      interrupt context
    - Add vis_rounding.patch, Fixes rounding issues in vis.c

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Sun, 20 Dec 2009 00:24:11 +0100

batman-adv-kernelland (0.2-2) unstable; urgency=low

  * Recommend batctl instead of deprecated batman-adv-battool

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Sun, 08 Nov 2009 23:17:12 +0100

batman-adv-kernelland (0.2-1) unstable; urgency=low

  * New Upstream Version
  * Convert to 3.0 (quilt) source format

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Sun, 08 Nov 2009 14:41:07 +0100

batman-adv-kernelland (0.2~beta~svn1453-1) experimental; urgency=low

  * New Upstream Snapshot

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Thu, 22 Oct 2009 23:03:21 +0200

batman-adv-kernelland (0.2~beta~svn1440-1) experimental; urgency=low

  * New Upstream Snapshot
  * debian/patches:
    - Remove upstream merged patches disable-csum-offloading.patch,
      filled_socketbuffer.patch

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Thu, 15 Oct 2009 20:14:06 +0200

batman-adv-kernelland (0.2~beta~svn1436-1) experimental; urgency=low

  * New Upstream Snapshot
  * debian/patches:
    - Remove upstream merged patches inactive_interface.patch,
      uninitialised_socket.patch, correct_vis_entries.patch,
      oops_deactivated_interface.patch, clamp_ttl.patch, netdevice_ops.patch
    - Remove patches which cannot be backported, linux-2.6.19.patch,
      linux-2.6.18.patch, linux-2.6.17.patch, linux-2.6.15.patch

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Sun, 13 Sep 2009 20:25:08 +0200

batman-adv-kernelland (0.2~beta~svn1397-1) experimental; urgency=low

  * New Upstream Version
  * Upgraded to policy 3.8.3, no changes required

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Sun, 16 Aug 2009 12:43:04 +0200

batman-adv-kernelland (0.2~beta~svn1370-1) experimental; urgency=low

  * New Upstream Snapshot

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Thu, 06 Aug 2009 19:25:31 +0200

batman-adv-kernelland (0.2~beta~svn1336-1) experimental; urgency=low

  * New Upstream Snapshot (Closes: #537149)
  * debian/patches:
    - Remove upstream merged patches 100-iface-after-forward-broadcast.patch,
      101-rcu_iflist.patch, 102-log-irqenable-sleep.patch,
      103-icmp-userspace-read.patch, 104-endless-recv.patch,
      105-icmp-check.patch
  * Remove quilt due to removed patches
  * Recommend batctl instead of transitional package batman-adv-battool
  * Update copyright years in debian/changelog

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Wed, 15 Jul 2009 17:35:14 +0200

batman-adv-kernelland (0.1-13) unstable; urgency=low

  * Correct minor dep3 tagging problems in debian/patches/
  * Provide batman-adv-dkms package that uses DKMS to dynamically build modules
    for the local kernel

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Tue, 20 Oct 2009 17:39:11 +0200

batman-adv-kernelland (0.1-12) unstable; urgency=low

  * debian/patches:
    - Add filled_socketbuffer.patch, Fixing race condition while handling lots
      of data
    - Add disable-csum-offloading.patch, Disable checksum offloading

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Thu, 15 Oct 2009 19:41:36 +0200

batman-adv-kernelland (0.1-11) unstable; urgency=low

  * Upgraded to policy 3.8.3, no changes required
  * Add README.source with information about patch management
  * debian/patches:
    - Change to dep3 patch tagging guidelines
    - Remove number before patches as order is given by debian/patches/series
    - Add inactive_interface.patch, Disable originator output when interface is
      disabled
    - Add uninitialised_socket.patch, Don't read from uninitialised socket
    - Add correct_vis_entries.patch, Calculate correct number of vis_entries
      when receiving undersized packet
    - Add oops_deactivated_interface.patch, Fix crash when sending vis packets
      on disabled interface
    - Add clamp_ttl.patch, Don't forward packets with ttl 255 after receiving
      packet with ttl 0

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Sun, 13 Sep 2009 20:07:24 +0200

batman-adv-kernelland (0.1-10) unstable; urgency=low

  * debian/patches:
    - Add 106-netdevice_ops.patch, fix compilation against linux-2.6.31-rc1
      (Closes: #534631)
    - Add 107-linux-2.6.19.patch, 108-linux-2.6.18.patch,
      109-linux-2.6.17.patch, 110-linux-2.6.15.patch, backport to linux-2.6.15

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Fri, 07 Aug 2009 22:44:56 +0200

batman-adv-kernelland (0.1-9) unstable; urgency=low

  * debian/rules:
    - Use the kernel makefiles directly to build the module to match
      linux-modules-extra-2.6 way of building it
    - Add get-orig-source target to retrieve source
  * debian/patches:
    - 103-outoftree_kbuild.patch, remove due to different linux module build
      approach
    - Add 103-icmp-userspace-read.patch, read complete icmp packet from
      userspace
    - Add 104-endless-recv.patch, consume even ignored packets to allow kernel
      receive thread to sleep
    - Add 105-icmp-check.patch, check for correct icmp version before sending it
  * Convert debian/copyright to new dep5 version


=== debian/control ===
Source: batman-adv-kernelland
Section: kernel
Priority: extra
Maintainer: Simon Wunderlich <siwu@hrz.tu-chemnitz.de>
Uploaders: Sven Eckelmann <sven.eckelmann@gmx.de>
Dm-Upload-Allowed: yes
Homepage: http://www.open-mesh.net/
Standards-Version: 3.8.3
Vcs-Browser: http://git.debian.org/?p=collab-maint/batman-adv-kernelland.git
Vcs-Git: git://git.debian.org/git/collab-maint/batman-adv-kernelland.git
Build-Depends: debhelper (>= 7)
Build-Depends-Indep: bzip2

Package: batman-adv-source
Architecture: all
Depends: ${misc:Depends}, module-assistant, debhelper (>= 7), make, bzip2
Recommends: batctl
Description: Source for the batman-advanced kernel module
 This package provides the source code for the batman-adv-source kernel modules.
 Kernel source or headers are required to compile these modules.
 .
 B.A.T.M.A.N. (better approach to mobile ad-hoc networking) is a new routing
 protocol for multi-hop ad-hoc mesh networks. B.A.T.M.A.N.-advanced is the
 implementation of this protocol on ISO/OSI Layer 2, allowing mesh networks to
 be used as a virtual switch. With this approach, LANs and WANs can be easily
 integrated, and more protocols (like DHCP, IPv6) are supported.

Package: batman-adv-dkms
Architecture: all
Depends: ${misc:Depends}, dkms (>= 2.1.0.0)
Recommends: batctl
Description: DKMS Source for the batman-advanced kernel module
 This package contains the source for the batman-adv-source kernel modules,
 packaged with approriate configuration for DKMS to build new modules
 dynamically.
 .
 B.A.T.M.A.N. (better approach to mobile ad-hoc networking) is a new routing
 protocol for multi-hop ad-hoc mesh networks. B.A.T.M.A.N.-advanced is the
 implementation of this protocol on ISO/OSI Layer 2, allowing mesh networks to
 be used as a virtual switch. With this approach, LANs and WANs can be easily
 integrated, and more protocols (like DHCP, IPv6) are supported.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper. 
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# This version is for a hypothetical package that can build a kernel modules
# architecture-dependant package via make-kpkg, as well as an
# architecture-independent module source package, and other packages
# either dep/indep for things like common files or userspace components
# needed for the kernel modules.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# some default definitions, important!
# 
# Name of the source package
psource:=batman-adv-source
dkmssource:=batman-adv-dkms

# The short upstream name, used for the module source directory
sname:=batman-adv

version:= $(shell dpkg-parsechangelog | grep ^Version: | cut -d' ' -f2 \
            | cut -d- -f1)

### KERNEL SETUP
### Setup the stuff needed for making kernel module packages
### taken from /usr/share/kernel-package/sample.module.rules

# prefix of the target package name
PACKAGE=batman-adv-modules
# modifieable for experiments or debugging m-a
MA_DIR=/usr/share/modass
# load generic variable handling
-include $(MA_DIR)/include/generic.make
# load default rules, including kdist, kdist_image, ...
-include $(MA_DIR)/include/common-rules.make
  
# module assistant calculates all needed things for us and sets
# following variables:
# KSRC (kernel source directory), KVERS (kernel version string), KDREV
# (revision of the Debian kernel-image package), CC (the correct
# compiler), VERSION (the final package version string), PKGNAME (full
# package name with KVERS included), DEB_DESTDIR (path to store DEBs)
  
# The kdist_config target is called by make-kpkg modules_config and
# by kdist* rules by dependency. It should configure the module so it is
# ready for compilation (mostly useful for calling configure).
# prep-deb-files from module-assistant creates the neccessary debian/ files 
kdist_config: prep-deb-files
  
# the kdist_clean target is called by make-kpkg modules_clean and from
# kdist* rules. It is responsible for cleaning up any changes that have
# been made by the other kdist_commands (except for the .deb files created)
#kdist_clean: clean
kdist_clean: 
	$(MAKE) $(MFLAGS) -f debian/rules clean
	$(MAKE) -C $(KSRC) M=$(CURDIR) clean

### end  KERNEL SETUP


k = $(shell echo $(KVERS) | grep -q ^2.6 && echo k)


# the binary-modules rule is invoked by module-assistant while processing the
# kdist* targets. It is called by module-assistant or make-kpkg and *not*
# during a normal build
binary-modules-stamp:
	dh_testroot
	dh_prep
	dh_installdirs lib/modules/$(KVERS)/kernel/net

	# Build the module
	$(MAKE) -C $(KSRC) M=$(CURDIR)

	# Install the module
	cp batman-adv.$ko debian/$(PKGNAME)/lib/modules/$(KVERS)/kernel/net

	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol -- -v$(VERSION)
	dh_md5sums
	dh_builddeb --destdir=$(DEB_DESTDIR)
	dh_prep
	touch $@
	


binary-modules: binary-modules-stamp
	dh_testdir

	# Add here command to compile/build the package.
	#$(MAKE)


build:

clean:
	dh_testdir
	dh_testroot

	# Add here commands to clean up after the build process.
	#
	# clean can be run from module assistant or the original package rules file. 
	
	dh_clean

install: DH_OPTIONS=
install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	dh_installdocs

###########################
# setup batman-adv-source #
###########################
	# Create the directories to install the source into
	dh_installdirs -p$(psource)  usr/src/modules/$(sname)/debian
	dh_installdirs -p$(dkmssource)  usr/src/$(sname)-$(version)

	# Copy only the driver source to the proper location
	cp *.c *.h Makefile* README  \
		debian/$(psource)/usr/src/modules/$(sname)
	cp *.c *.h Makefile* README  \
		debian/$(dkmssource)/usr/src/$(sname)-$(version)
	mv debian/$(psource)/usr/src/modules/$(sname)/Makefile.kbuild \
	   debian/$(psource)/usr/src/modules/$(sname)/Makefile
	mv debian/$(dkmssource)/usr/src/$(sname)-$(version)/Makefile.kbuild \
	   debian/$(dkmssource)/usr/src/$(sname)-$(version)/Makefile
	# Copy the needed debian/ pieces to the proper location
	cp debian/*modules.in* \
		debian/$(psource)/usr/src/modules/$(sname)/debian
	cp debian/changelog debian/copyright debian/rules\
		debian/compat debian/control debian/$(psource)/usr/src/modules/$(sname)/debian/

	mkdir -p debian/$(psource)/usr/share/doc/$(psource)
	cp debian/copyright debian/$(psource)/usr/share/doc/$(psource)
	mkdir -p debian/$(dkmssource)/usr/share/doc/$(dkmssource)
	cp debian/copyright debian/$(dkmssource)/usr/share/doc/$(dkmssource)

	mkdir -p debian/$(psource)$(MA_DIR)/packages/
	cd debian/$(psource)$(MA_DIR)/packages/ && ln -sf default.sh $(psource)
	cd debian/$(psource)/usr/src && tar c modules | bzip2 -9 > $(sname).tar.bz2 && rm -rf modules

	sed -e 's/[@]VERSION[@]/$(version)/' debian/dkms.conf.in \
	    > debian/$(dkmssource)/usr/src/$(sname)-$(version)/dkms.conf

	dh_install

# Build architecture-independent files here.
# Pass -i to all debhelper commands in this target to reduce clutter.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs  -i CHANGELOG
	dh_installman -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch:

binary: binary-indep

get-orig-source:
	$(CURDIR)/debian/get-orig-source.sh

.PHONY: build clean binary-indep binary-arch binary install binary-modules kdist kdist_configure kdist_image kdist_clean get-orig-source

=== debian/watch ===
version=3
opts="uversionmangle=s/-(alpha|beta|rc)/~$1/" \
 http://downloads.open-mesh.net/batman/stable/sources/batman-adv-kernelland/batman-adv-kernelland-(.*).tar.gz

## batman-adv-kernelland 2010.0.0

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2007-2009 B.A.T.M.A.N. contributors:
+# Copyright (C) 2007-2010 B.A.T.M.A.N. contributors:
 #
 # Marek Lindner, Simon Wunderlich
 #

=== debian/changelog ===
batman-adv-kernelland (2010.0.0-2) unstable; urgency=low

  * Correct destination path of dkms module
  * Upgraded to policy 3.9.1, no changes required
  * debian/patches:
    - Add foreign_stats.patch, Don't increment stats of foreign device (Closes:
      #593473)
    - Add orig_hash_deadlock.patch, unify orig_hash_lock spinlock handling to
      avoid deadlocks (Closes: #593519)
    - Add register_event.patch, Create batman_if only on register event (Closes:
      #593471)
    - Add netdev_reference.patch, Don't use net_dev after dev_put (Closes:
      #593472)
    - Add mac_packet_buff_check.patch, Don't write in not allocated packet_buff
      (Closes: #593724)

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Sat, 21 Aug 2010 10:47:59 +0200

batman-adv-kernelland (2010.0.0-1) unstable; urgency=low

  * New Upstream Version
  * Download snapshots from git repository when using debian/get-orig-source.sh
  * Correct URL in watch file to match newer releases
  * debian/patches:
    - Remove upstream merged patches: bat0_failure_memleak.patch,
      limit_queues.patch, seqno_redesign.patch, update_ethhdr_after_copy.patch

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Sat, 19 Jun 2010 00:02:48 +0200

batman-adv-kernelland (0.2.1-2) unstable; urgency=low

  * debian/patches:
    - Add seqno_redesign.patch, Reorganize sequence number handling to reduce
      broadcast loops
    - Add limit_queues.patch, Limit queue lengths for batman and broadcast
      packets
    - Add bat0_failure_memleak.patch, kfree_skb() in interface_tx() in error
      case
    - Add update_ethhdr_after_copy.patch, Update pointer to ethhdr after
      skb_copy

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Mon, 26 Apr 2010 22:33:03 +0200

batman-adv-kernelland (0.2.1-1) unstable; urgency=low

  * New Upstream Version
  * Remove outdated README.source
  * Updated debian/copyright
  * debian/patches:
    - Remove upstream merged irqdeadlock.patch, missing_kfree.patch,
      random_mac.patch, route_flapping.patch, vis_rounding.patch

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Tue, 23 Mar 2010 01:11:04 +0100

batman-adv-kernelland (0.2-6) unstable; urgency=low

  * debian/copyright: Update copyright years
  * Upgraded to policy 3.8.4, no changes required
  * Use dh_dkms to provide DKMS support

 -- Sven Eckelmann <sven.eckelmann@gmx.de>  Mon, 01 Mar 2010 12:51:54 +0100

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Uploaders: Sven Eckelmann <sven.eckelmann@gmx.de>
 Dm-Upload-Allowed: yes
 Homepage: http://www.open-mesh.net/
-Standards-Version: 3.8.3
+Standards-Version: 3.9.1
 Vcs-Browser: http://git.debian.org/?p=collab-maint/batman-adv-kernelland.git
 Vcs-Git: git://git.debian.org/git/collab-maint/batman-adv-kernelland.git
-Build-Depends: debhelper (>= 7)
+Build-Depends: debhelper (>= 7), dkms (>= 2.1.1.1-2)
 Build-Depends-Indep: bzip2
 
 Package: batman-adv-source
@@ -27,7 +27,7 @@
 
 Package: batman-adv-dkms
 Architecture: all
-Depends: ${misc:Depends}, dkms (>= 2.1.0.0)
+Depends: ${misc:Depends}
 Recommends: batctl
 Description: DKMS Source for the batman-advanced kernel module
  This package contains the source for the batman-adv-source kernel modules,

=== debian/rules ===
--- 
+++ 
@@ -152,9 +152,7 @@
 	cd debian/$(psource)$(MA_DIR)/packages/ && ln -sf default.sh $(psource)
 	cd debian/$(psource)/usr/src && tar c modules | bzip2 -9 > $(sname).tar.bz2 && rm -rf modules
 
-	sed -e 's/[@]VERSION[@]/$(version)/' debian/dkms.conf.in \
-	    > debian/$(dkmssource)/usr/src/$(sname)-$(version)/dkms.conf
-
+	dh_dkms -V
 	dh_install
 
 # Build architecture-independent files here.
